﻿using HarmonyLib;
using System.Reflection;
using System;
using System.Collections.Generic;
using UnityEngine;

public class PauseMod : Mod
{
    private Network_Player player = null;
    private const string harmonyId = "com.blargs.raft.pause";
    private Harmony harmony = null;

    private void Start()
    {
        harmony = new Harmony(harmonyId);
        harmony.PatchAll(Assembly.GetExecutingAssembly());
        Debug.Log("PauseMod loaded!");
    }

    public void Update()
    {
        if (player == null)
        {
            player = RAPI.GetLocalPlayer();
        }
        else
        {
            SavedStats stats = SavedStats.GetSavedPlayerStats(player.name);
            if (stats.IsPaused)
            {
                player.Stats.stat_hunger.Normal.Value = stats.Hunger;
                player.Stats.stat_thirst.Value = stats.Thirst;
            }
        }
    }

    public void OnModUnload()
    {
        Debug.Log("PauseMod has been unloaded!");
        harmony.UnpatchAll(harmonyId);
        Destroy(gameObject);
    }
}

class SavedStats
{
    private static Dictionary<String, SavedStats> INSTANCE = new Dictionary<string, SavedStats>();

    public static SavedStats GetSavedPlayerStats(String playerName)
    {
        if (!INSTANCE.TryGetValue(playerName, out SavedStats stats))
        {
            stats = new SavedStats();
            INSTANCE.Add(playerName, stats);
        }
        return stats;
    }

    public float Thirst
    {
        get;
        set;
    }
    public float Hunger
    {
        get;
        set;
    }
    public bool IsPaused
    {
        get;
        set;
    }

    private SavedStats()
    {
        IsPaused = false;
    }
}
